unit orbObjetoCurso;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, ComObj, StdVcl,
  CorbaObj, ORBDelCurso_TLB;

type

  TObjetoCurso = class(TCorbaImplementation, IObjetoCurso)
  private
    { Private declarations }
  public
    { Public declarations }
  protected
    function DeCabeza(const Cadena: WideString): WideString; safecall;
    function TuQuienEres: WideString; safecall;
  end;

implementation

uses CorbInit;

function TObjetoCurso.DeCabeza(const Cadena: WideString): WideString;
var
  i : Integer;
begin

  Result := '';
  // Este for invierte los caracteres del mensaje
  for i := Length(Cadena) downto 0 do Result := Result + Cadena[i];

end;

function TObjetoCurso.TuQuienEres: WideString;
begin
  Result := 'Yo soy el objeto ObjetoCurso, implementado en Delphi';
end;

initialization
  TCorbaObjectFactory.Create('ObjetoCursoFactory', 'ObjetoCurso', 'IDL:ORBDelCurso/ObjetoCursoFactory:1.0', IObjetoCurso,
    TObjetoCurso, iSingleInstance, tmSingleThread);
end.