import java.io.*;
import java.lang.*;
import org.omg.CORBA.*;
import ORBDelCurso.*;

class ObjetoCursoServidor extends ORBDelCurso._ObjetoCursoFactoryImplBase {


    /** Construct a persistently named object. */
    public ObjetoCursoServidor(java.lang.String name) {
	super(name);
    }
    /** Construct a transient object. */
    public ObjetoCursoServidor() {
	super();
    }
    
   public IObjetoCurso CreateInstance(String instanceName) {
       IObjetoCurso resultado = new ObjetoCurso();
       return ( resultado );
   };

   // Now let's add our main() function here - Note that this is FOR THE SERVER, not for the client.:
  public static void main( String[] args ) {
    try
    {

       ORB orb = ORB.init( args, null );
       System.out.println(orb.getClass().getName());
       BOA boa = orb.BOA_init();
       System.out.print("ORB inicializado.");
       ObjetoCursoServidor impl = new ObjetoCursoServidor("ObjetoCurso");
       System.out.print(impl.toString()+"\n");
       boa.obj_is_ready(impl);
       String ior = orb.object_to_string(impl);
       
       /* Con este try/finally usted podr ejecutar este servidor 
	y grabar el IOR en un archivo para que funcione en ORBs ajenos
       a Visibroker. */
       try
       {
         PrintWriter pw = new PrintWriter( new BufferedWriter ( new FileWriter("../ObjetoCursoFactory.ior")));
         pw.println(ior);
         pw.close();

       } catch (IOException exc) {
          exc.printStackTrace(System.err);
        };

       
       boa.impl_is_ready();

     } catch ( SystemException sysx ) {
       System.err.println(sysx);
     }

  };

};
